set echo on
set numwidth 16
column deptno format 999999
column sequence$$ format 999999999999
column dmltype$$ format a10
column old_new$$ format a10
column change_vector$$ format a15
column m_row$$ format a20
clear screen
remark  Kan je een materialized view log zonder opties aanmaken op DEPT?
remark
desc dept
create materialized view log on dept
/
pause
clear screen
remark  Een materialized view log WITH ROWID
remark
create materialized view log on dept with rowid
/
desc mlog$_dept
pause
select * from mlog$_dept
/
pause
clear screen
remark  En hoe zien de rijen eruit in een MV log WITH ROWID?
remark
select object_type
  from dba_objects
 where object_name = 'MLOG$_DEPT'
/
pause
insert into dept values (50,'IT','Utrecht')
/
select * from mlog$_dept
/
remark  xid$$ == transaction id
remark  A combination of the elements of the triplet (undo segment number, undo slot, undo sequence).
remark  It is the binary concatenation of the three numbers shifted by (48, 32, 0) bits respectively.
pause
clear screen
remark  Na de INSERT nu een UPDATE en een DELETE
remark
update dept
   set loc = 'Nieuwegein'
 where deptno = 50
/
delete dept
 where deptno = 50
/
select * from mlog$_dept
/
pause
clear screen
remark  Als DEPT wel een primary key constraint heeft ...
remark
drop materialized view log on dept
/
alter table dept add constraint dept_pk primary key (deptno)
/
create materialized view log on dept
/
desc mlog$_dept
pause
clear screen
remark  Als een tabel een primary key constraint heeft, dan is WITH PRIMARY KEY optioneel
remark
drop materialized view log on dept
/
create materialized view log on dept with primary key
/
desc mlog$_dept
pause
clear screen
remark  Hoe zien de rijen eruit in een MV log WITH PRIMARY KEY na een INSERT, UPDATE en een DELETE?
remark
insert into dept values (50,'IT','Utrecht')
/
update dept
   set loc = 'Nieuwegein'
 where deptno = 50
/
delete dept
 where deptno = 50
/
select * from mlog$_dept
/
pause
clear screen
remark  Een MV log WITH OBJECT ID
remark
drop materialized view log on dept
/
create materialized view log on dept with object id
/
pause
clear screen
remark  Wat gebeurt er met de MV log als je WITH SEQUENCE specificeert?
remark
create materialized view log on dept with sequence
/
desc mlog$_dept
pause
clear screen
remark  Hoe wordt de SEQUENCE$$-kolom gevuld na een INSERT, UPDATE, UPDATE en een DELETE?
insert into dept values (50,'IT','Utrecht')
/
update dept
   set loc = 'Nieuwegein'
 where deptno = 50
/
update dept 
   set loc = 'De Meern'
 where deptno = 50
/
delete dept
 where deptno = 50
/
pause
clear screen
remark  De inhoud van de MV log WITH SEQUENCE na een INSERT, UPDATE, UPDATE en een DELETE
select * from mlog$_dept
/
pause
clear screen
remark  WITH COMMIT SCN
remark
drop materialized view log on dept
/
create materialized view log on dept with commit scn
/
desc mlog$_dept
pause
desc all_summap
desc sys.snap_xcmt$
pause
clear screen
remark  Wat staat er in ALL_SUMMAP na een INSERT, UPDATE, UPDATE en een DELETE?
remark
select * from all_summap
/
insert into dept values (50,'IT','Utrecht')
/
update dept
   set loc = 'Nieuwegein'
 where deptno = 50
/
update dept 
   set loc = 'De Meern'
 where deptno = 50
/
delete dept
 where deptno = 50
/
pause
clear screen
remark De inhoud van de MV log en ALL_SUMMAP
remark
select * from mlog$_dept
/
select * from all_summap
/
pause
commit
/
select * from all_summap
/
pause
clear screen
remark  Je kunt kolommen niet dubbel opgeven
remark
drop materialized view log on dept
/
create materialized view log on dept with (deptno,dname,loc)
/
pause
create materialized view log on dept with (dname,loc)
/
desc mlog$_dept
pause
clear screen
remark  Een volledig uitgeruste MV log
remark
drop materialized view log on dept
/
create materialized view log on dept with rowid, sequence (deptno,dname,loc)
/
desc mlog$_dept
pause
clear screen
remark  Tot nu toe gebruiken we EXCLUDING NEW VALUES (de default). Wat is het effect van INCLUDING NEW VALUES?
remark
drop materialized view log on dept
/
create materialized view log on dept including new values
/
desc mlog$_dept
pause
clear screen
remark  INCLUDING NEW VALUES na een INSERT, UPDATE, UPDATE en een DELETE
remark
insert into dept values (50,'IT','Utrecht')
/
update dept
   set loc = 'Nieuwegein'
 where deptno = 50
/
update dept 
   set loc = 'De Meern'
 where deptno = 50
/
delete dept
 where deptno = 50
/
pause
clear screen
remark  INCLUDING NEW VALUES na een INSERT, UPDATE, UPDATE en een DELETE
remark
select * from mlog$_dept
/
pause
set echo off
drop materialized view log on dept
/
alter table dept drop constraint dept_pk
/
