set echo on
clear screen
create table myemp as select * from emp
/
pause
alter table myemp add primary key (empno)
/
pause
clear screen
remark  Zet een incrementeel verversende MV op de tabel MYEMP
remark
create materialized view log on myemp
  with primary key
/
pause
create materialized view emp_mv
  refresh fast on commit
as
select empno
     , ename
     , job
     , sal
     , deptno
  from myemp
 where deptno = 10
/
pause
select * from emp_mv
/
pause
clear screen
remark  En toon aan dat de MV inderdaad snel/incrementeel ververst
remark
insert into myemp (empno,ename,job,sal,deptno)
values (7777,'VAN WIJK','JANITOR',500,10)
/
commit
/
select * from emp_mv
/
pause
drop materialized view emp_mv
/
clear screen
remark  Restriction 1: The materialized view must not contain references to non-repeating expressions like SYSDATE and ROWNUM.
remark
delete myemp where empno = 7777
/
create materialized view emp_mv
  refresh fast on commit
as
select empno
     , ename
     , job
     , sal
     , deptno
     , sysdate now
  from myemp
 where deptno = 10
/
pause
clear screen
remark  Restriction 3: It cannot contain a SELECT list subquery.
remark
create materialized view emp_mv
  refresh fast on commit
as
select empno
     , ename
     , job
     , sal
     , deptno
     , (select emp.ename from emp where emp.empno = myemp.mgr) manager_name
  from myemp
 where deptno = 10
/
pause
drop materialized view emp_mv
/
clear screen
remark  Restriction 5: It cannot contain a MODEL clause
remark
create materialized view emp_mv
  refresh fast on commit
as
select empno
     , ename
     , job
     , sal
     , deptno
  from myemp
 where deptno = 10
 model
       dimension by (empno)
       measures (ename,job,sal,deptno,0 copysal)
       ( copysal[any] = sal[cv()]
       )
/
pause
set echo off
drop table myemp purge
/
