set echo on
column statement_id format a12
column mvowner format a7
column mvname format a6
column possible format a8
column seq format 99999
column msgno format 9999
column related_num format 9999999999
column msgtxt format a45
column related_text format a12
column capability_name format a29
truncate table mv_capabilities_table
/
clear screen
remark  Zo ziet de MV_CAPABILITIES_TABLE eruit
remark
desc mv_capabilities_table
pause
clear screen
remark  Zet de beginsituatie weer op
remark
create table myemp as select * from emp
/
alter table myemp add primary key (empno)
/
create materialized view log on myemp
  with rowid (empno)
/
pause
clear screen
remark  Restriction 1: The materialized view must not contain references to non-repeating expressions like SYSDATE and ROWNUM.
remark
begin
  dbms_mview.explain_mview
  ( 'create materialized view emp_mv
  refresh fast on commit
as
select empno
     , ename
     , job
     , sal
     , deptno
     , sysdate now
  from myemp
 where deptno = 10'
  );
end;
/
pause
select seq
     , statement_id
     , mvowner
     , mvname
     , capability_name
     , possible
     , related_num
     , related_text
     , msgno
     , msgtxt
  from mv_capabilities_table
 order by seq
/
pause
clear screen
remark  Restriction 3: It cannot contain a SELECT list subquery.
remark
begin
  dbms_mview.explain_mview
  ('create materialized view emp_mv
  refresh fast on commit
as
select empno
     , ename
     , job
     , sal
     , deptno
     , (select emp.ename from emp where emp.empno = myemp.mgr) manager_name
  from myemp
 where deptno = 10'
  );
end;
/
pause
select seq
     , statement_id
     , mvowner
     , mvname
     , capability_name
     , possible
     , related_num
     , related_text
     , msgno
     , msgtxt
  from mv_capabilities_table
 order by seq
/
pause
drop materialized view emp_mv
/
clear screen
remark  Restriction 5: It cannot contain a MODEL clause
remark
begin
  dbms_mview.explain_mview
  ('create materialized view emp_mv
  refresh fast on commit
as
select empno
     , ename
     , job
     , sal
     , deptno
  from myemp
 where deptno = 10
 model
       dimension by (empno)
       measures (ename,job,sal,deptno,0 copysal)
       ( copysal[any] = sal[cv()]
       )'
  );
end;
/
pause
clear screen
remark  Toon alle kolommen van de MV_CAPABILITIES_TABLE
remark
select seq
     , statement_id
--     , mvowner
--     , mvname
     , capability_name
     , possible
     , related_num
     , related_text
     , msgno
     , msgtxt
  from mv_capabilities_table
 where mvowner = 'RWIJK'
   and mvname = 'EMP_MV'
 order by seq
/
pause
column msgtxt format a83
clear screen
remark  En toon alleen capability_name, possible, msgtxt voor de capabilities met betrekking tot FAST REFRESH
remark
select capability_name
     , possible
     , msgtxt
  from mv_capabilities_table
 where mvowner = 'RWIJK'
   and mvname = 'EMP_MV'
   and capability_name like 'REFRESH%'
 order by seq
/
pause
set echo off
drop table myemp purge
/
