set echo on
clear screen
remark  Maak een tabel aan waarin maandelijkse percentages staan die opgeteld op 100% moeten uitkomen
remark
create table payment_percentages
( customer_id number(9)
, month number(2,0)
, percentage number(3,0)
)
/
pause
create materialized view log on payment_percentages
with rowid (customer_id,percentage) including new values
/
pause
clear screen
remark  Maak een aggregatie MV waarin we het totale percentage berekenen en zet daar een check constraint op
remark
create materialized view mv
refresh fast on commit
as
select customer_id
     , sum(percentage) total_percentage
     , count(*) count_all
     , count(percentage) count_percentage
  from payment_percentages
 group by customer_id
/
pause
alter materialized view mv
  add constraint mv_total_percentage_100_ck
  check (total_percentage = 100)
/
pause
desc mv
pause
clear screen
remark  Vul de tabel met 8 maanden van 10% en 4 maanden van 5%, samen 100%
remark
insert into payment_percentages
 select 1
      , level
      , 10
   from dual
connect by level <= 8
/
insert into payment_percentages
 select 1
      , 8+ level
      , 5
   from dual
connect by level <= 4
/
pause
clear screen
remark  Een controle-zoekvraag die bevestigt dat de percentages samen 100% zijn.
remark
select customer_id
     , month
     , sum(percentage)
  from payment_percentages
 group by rollup ((customer_id,month))
 order by month
/
pause
commit
/
pause
clear screen
remark  En nu een UPDATE die het totaalpercentage boven de 100% uittilt
remark
update payment_percentages
   set percentage = 15
 where customer_id = 1
   and month = 11
/
pause
select customer_id
     , month
     , sum(percentage)
  from payment_percentages
 group by rollup ((customer_id,month))
 order by month
/
pause
commit
/
pause
set echo off
drop materialized view mv
/
drop table payment_percentages purge
/
