set echo on
clear screen
remark  The project assignment start and end dates for an employee should lie between the start and end dates defined for the project
remark
create table projects
( id number(9) primary key
, name varchar2(30) not null
, startdate date not null
, enddate date not null
)
/
create table project_assignments
( id number(9) primary key
, employee varchar2(10) not null
, project_id number(9) not null references projects(id)
, startdate date not null
, enddate date not null
)
/
pause
clear screen
remark  We gaan een join MV maken, waarvoor we MV logs nodig hebben met een rowid
remark
create materialized view log on projects with rowid
/
create materialized view log on project_assignments with rowid
/
pause
create materialized view projects_date_ranges
refresh fast on commit
as
select p.rowid prid
     , pa.rowid parid
     , p.startdate project_startdate
     , p.enddate project_enddate
     , pa.startdate assignment_startdate
     , pa.enddate assignment_enddate
  from projects p
     , project_assignments pa
 where p.id = pa.project_id
/
pause
clear screen
remark  En de controle implementeren we nu als een simpele check constraint op de MV
remark
alter table projects_date_ranges
  add constraint valid_assignment_periods_ck
  check (   assignment_startdate >= project_startdate
        and assignment_enddate <= project_enddate
        )
/
pause
clear screen
remark  En een controle dat goede data nog steeds toegevoegd kan worden
remark
insert into projects
values (1,'MJPS',date '2013-01-01',date '2013-12-31')
/
insert into project_assignments
values (1,'ALAN',1,date '2013-01-01',date '2013-06-30')
/
commit
/
pause
clear screen
remark  En een controle dat foute data geweigerd wordt
remark
insert into project_assignments
values (2,'BOB',1,date '2013-01-01',date '2014-01-01')
/
commit
/
pause
set echo off
drop materialized view projects_date_ranges
/
drop table project_assignments purge
/
drop table projects purge
/
