set echo on
clear screen
create materialized view log on emp with rowid,sequence (job,sal) including new values
/
create materialized view emp_mv
  refresh fast on commit
as
select job
     , avg(sal) avg_sal
     , count(sal) count_sal
     , count(*) count_all
  from emp
 group by job
/
select * from emp_mv
/
pause
begin
  dbms_mview.purge_log('EMP');
end;
/
pause
insert into emp (empno,ename,job,sal)
values (7777,'VAN WIJK','CLERK',5000)
/
commit
/
pause
remark
remark  ORA-12034: materialized view log on "string"."string" younger than last refresh
remark
remark  Cause:	 The materialized view log was younger than the last refresh.
remark
remark  Action:	 A complete refresh is required before the next fast refresh.
remark
pause
exec dbms_mview.refresh('emp_mv','c')
insert into emp (empno,ename,job,sal)
values (7777,'VAN WIJK','CLERK',5000)
/
commit
/
select * from emp_mv
/
pause
select object_type
  from user_objects
 where object_name = 'EMP_MV'
/
pause
drop materialized view emp_mv
/
create table emp_mv
as
select job
     , avg(sal) avg_sal
     , count(sal) count_sal
     , count(*) count_all
  from emp
 group by job
/
create materialized view emp_mv
  on prebuilt table
  refresh fast on commit
as
select job
     , avg(sal) avg_sal
     , count(sal) count_sal
     , count(*) count_all
  from emp
 group by job
/
pause
begin
  dbms_mview.purge_log('EMP');
end;
/
insert into emp (empno,ename,job,sal)
values (7777,'VAN WIJK','CLERK',5000)
/
commit
/
pause
select object_type
  from user_objects
 where object_name = 'EMP_MV'
/
pause
drop materialized view emp_mv
/
select object_type
  from user_objects
 where object_name = 'EMP_MV'
/
pause
create materialized view emp_mv
  on prebuilt table
  refresh fast on commit
as
select job
     , avg(sal) avg_sal
     , count(sal) count_sal
     , count(*) count_all
  from emp
 group by job
/
pause
insert into emp (empno,ename,job,sal)
values (7777,'VAN WIJK','CLERK',5000)
/
commit
/
select * from emp_mv
/
pause
set echo off
drop materialized view emp_mv
/
drop table emp_mv purge
/
drop materialized view log on emp
/
delete emp
 where empno = 7777
/
commit
/
